#!/usr/bin/perl -w
use strict;
use warnings;

use Data::Dumper;
use HTML::Parser;

my @lstEquipes;
my @lstJournees;
my %matchs;

sub searchEquipe {
	my $equipe = shift;
	my $i;

	if ($equipe && $#lstEquipes) {
		for ($i = 0; $i < $#lstEquipes; $i++) {
			last if ($lstEquipes[$i] eq $equipe);
		}
	}

	return ((defined($i) && $lstEquipes[$i] eq $equipe) ? $i : undef);
}

{
	my ($nomClub, $col, $journee, $stateJournees) = (0, 0, 0, 0);
	my ($e1, $e2, $resu1, $resu2);
	sub start {
		my ($tag, $attr) = @_;
		#print "START=$tag\n";
		#while( my ($k, $v) = each %$attr ) {
		#	print "<$tag> key: $k, value: $v.\n";
		#}
	}

	sub end {
		my ($tag) = @_;
		#print "END=$tag\n";
	}

	sub text {
		my ($text) = @_;
		#print "TEXT=$text\n";
		$nomClub = 1 if ($text eq 'Equipe');
		$col = ($col + 1) % 10 if ($nomClub == 1 && $text !~ /\s*\r*\n+/);
		if ($col == 1 && $text ne 'Equipe') {
			$text =~ s/\xA0(.*)$/$1/; # suppression de l'espace inscable
			$text = 'Exempt' if ($text eq '0');
			print "equipe=$text\n";
			push(@lstEquipes, $text);
		}
		if ($text =~ /Poule.* - .*n (\d+) - du (..\/..\/..)/) {
			$nomClub = 0;
			$journee = $1;
			print "journee $1 du $2\n";
			push(@lstJournees, $2);
			$stateJournees = 1;
		} else {
			if ($stateJournees == 1) {
				if (defined($e1 = searchEquipe($text))) {
					$stateJournees = 2;
				}
			} elsif ($stateJournees == 2) {
				if (defined($e2 = searchEquipe($text))) {
					$stateJournees = 3;
				}
			} elsif ($stateJournees == 3) {
				$resu1 = $text;
				$stateJournees = 4;
			} elsif ($stateJournees == 4) {
				my ($score1, $score2);
				$resu2 = $text;
				if ($resu1 =~ /\d+/ && $resu2 =~ /\d+/) {
					if ($resu1 > $resu2) {
						$score1 = 3;
						$score2 = 1;
					} elsif ($resu1 < $resu2) {
						$score1 = 1;
						$score2 = 3;
					} else {
						$score1 = 2;
						$score2 = 2;
					}
				} else {
					$resu1 = "";
					$resu2 = "";
					$score1 = "";
					$score2 = "";
				}
				$matchs{$journee-1}{$e1.'-'.$e2} = "$resu1:$resu2:$score1:$score2".'::';
				$stateJournees = 1;
			}
		}
	}
}

my $parser = HTML::Parser->new();

# dfinition des mes evenements
$parser->handler( text  => \&text,  "dtext" );
$parser->handler( start => \&start, "tagname,attr" );
$parser->handler( end   => \&end,   "tagname" );
 
my $html = join('', <STDIN>);
$parser->parse($html);

#print Dumper(\@lstEquipes);
#print Dumper(\@lstJournees);
#print Dumper(\%matchs);

my $fh;
my $i;
open($fh, '>', 'tmp/equipes') or die $!;
foreach (@lstEquipes) {
	print $fh $_."\n";
}
close($fh);

open($fh, '>', 'tmp/journees') or die $!;
$i = 0;
foreach (@lstJournees) {
	$i++;
	print $fh "tour n $i du $_\n";
}
close($fh);

foreach my $journee (keys %matchs) {
	foreach my $match (keys %{$matchs{$journee}}) {
		open($fh, '>', "tmp/match-$journee-$match") or die $!;
		print $fh $matchs{$journee}{$match};
		close($fh);
	}
}

